#  vf48.defn.tcl

proc {Add_VF-48_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
#   set A32addrbase [third $addressinfo]
#   set interruptlevel [fourth $addressinfo]
#   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
      define-vme-register $name xVME CSR       "-a$A24addrbase -w24 -o0x00 -prw -d16 -zx"
      define-vme-register $name xVME CSR.Run       "-a$A24addrbase -w24 -o0x00 -prw -d16 -l1 -b0 -zd"
      define-vme-register $name xVME CSR.ExtTrig   "-a$A24addrbase -w24 -o0x00 -prw -d16 -l1 -b7 -zd"
      define-vme-register $name xVME CSR.CRC       "-a$A24addrbase -w24 -o0x00 -pro -d16 -l1 -b5 -zd"
      define-vme-register $name xVME CSR.DataRdy   "-a$A24addrbase -w24 -o0x00 -prw -d16 -l1 -b3 -zd"
      define-vme-register $name xVME ID        "-a$A24addrbase -w24 -o0x30 -pro -d16 -zx"
      define-vme-register $name xVME ParamData "-a$A24addrbase -w24 -o0x50 -prw -d16 -zx"
      define-vme-register $name xVME ParamID   "-a$A24addrbase -w24 -o0x60 -pwo -d16 -zx"
      define-vme-register $name xVME SoftTrig  "-a$A24addrbase -w24 -o0x70 -pwo -d16 -zx"
      define-vme-register $name xVME GrpEnable "-a$A24addrbase -w24 -o0x90 -prw -d16 -l6 -b0 -zx"
      define-vme-register $name xVME NbrFrames "-a$A24addrbase -w24 -o0xa0 -pro -d16 -zd"
      define-vme-register $name xVME Reset     "-a$A24addrbase -w24 -o0xb0 -pwo -d16 -zx"
      define-vme-register $name xVME DataFiFo  "-a$A24addrbase -w24 -o0x100 -pro -d32 -zx"

}


proc {VF-48_registers} {} {
    global registers_table

    set registers_table   {}

        lappend registers_table [list "CSR"  CSR]
        lappend registers_table [list "Firmware ID"  ID]
        lappend registers_table [list "Data Words Ready"  NbrFrames]
}


proc {VF-48_DAQ-reset} {args} {
#   vf48
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    write-vme-registers $module.Reset 0
}

proc {VF-48_DAQ-go} {args} {
#   vf48
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

    write-vme-registers $module.CSR.Run 1
}

proc {VF-48_DAQ-halt} {args} {
#   vf48
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

    write-vme-registers $module.CSR.Run 0
}

proc {VF-48_DAQ-setup} {args} {
#   vf48
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

    write-vme-registers $module.Reset 0
    write-vme-registers $module.GrpEnable 0x3f
}

#   for parameter save/restore
set {VF-48_registersavepatterns}  {CSR.ExtTrig GrpEnable}




