#vf48.tcl---GRT 4P module control frame


set frame
set frametitle "VF-48 Module Setup & Monitor"
set icontitle "VF48"

set modulename  vf48
set moduletype  "vf48"

loadsource common.vme

get-module-configuration   ;# sets module

set adc  0

set alladcs 0
set allmodules 0

set w2r(NBRF)    NbrFrames
set w2r(CSR)     CSR
set w2r(ENABLE)  GrpEnable
set w2r(RUN)     CSR.Run
set w2r(EXTTRIG) CSR.ExtTrig
set w2r(CRC)     CSR.CRC
set w2r(DRDY)    CSR.DataRdy

proc click-select-module {v} {
    global module
    set module $v
    click_redisplay
}

proc click-select-adc {v} {
    global adc
    set adc $v
    click_redisplay
}

proc click-software {} {
   global modulename
   inform [set modulename]sftwre start
}

proc click-widget {w v} {
    global w2r
    global modulename module
    global allmodules allchannels
    global CurrentVMEServer

    set register $w2r($w)
    if {$allchannels == 1} then {set register [string range $register 0 1]?[string range $register 3 end]}
    set value $v

    if {$allmodules == 0} then {
        write-vme-registers $modulename#$module.$register $value
    } else {
        set CurrentVMEServer [inform vmecontrol inquire Role]
        write-vme-registers $modulename#\[?,??\].$register $value
        set CurrentVMEServer [inform vmecontrol VMEmodule2server $modulename#$module]
    }

    click_redisplay
}

proc click_redisplay {args} {
    global modulename module adc
    global EGallow EGreport CurrentVMEServer
    global w2r

    :modify MODULE-NUM :value $module
    set CurrentVMEServer [inform vmecontrol VMEmodule2server $modulename#$module]

    set EGreport_SAVE $EGreport
    set EGreport -1

   set-busy

#    module parameters

   foreach w {EXTTRIG} {
       set register $w2r($w)
       set EGallow 0x2000a
       set value [read-vme-register $modulename#$module.$register]
       set EGallow 0xffffffff
       if {$value == 0x2000a} then {set value "BERR"}
       :modify $w :value $value
   }

   foreach w {NBRF CSR ENABLE RUN CRC DRDY} {
       set register $w2r($w)
       set EGallow 0x2000a
       set value [read-vme-register $modulename#$module.$register]
       set EGallow 0xffffffff
       if {$value == 0x2000a} then {set value "BERR"}
       :modify $w  :inactive F :value $value :inactive T
   }

#    current channel group parameters

   foreach p {2 4 5 10 12 13 15 16} {:modify P$p :value ""}

     set runstate [read-vme-register $modulename#$module.CSR.Run]
     if {$runstate == 0} {
         foreach p {2 4 5 12} {
             set param [ReadParameter $p]
             if {$param != "RDERR"} {
                 :modify P$p :value [expr $param]
             }
         }
         foreach p {13} {
             set param [ReadParameter $p]
             if {$param != "RDERR"} {
                 :modify P$p :value $param
             }
         }
     } else {
         set-footer "VF48 module parameters cannot be read or written while running"
     }

     if {$runstate == 0} {
         set mbit1 [ReadParameter 10]
         if {$mbit1 != "RDERR"} {
             :modify P10 :value $mbit1
             :modify B11 :value [expr ($mbit1 >> 1) & 1]
         }
         set mbit2 [ReadParameter 15]
         if {$mbit2 != "RDERR"} {
             :modify P15 :value $mbit2
             :modify B20 :value [expr $mbit2 & 1]
             :modify B21 :value [expr ($mbit2 >> 1) & 1]
         }
     } else {
         :modify B11 :value 0
         :modify B20 :value 0
         :modify B21 :value 0
         set-footer "VF48 module parameters cannot be read or written while running"
     }

   clear-busy
   set EGreport $EGreport_SAVE
}

proc SetParameter {p vl} {
    global modulename modulelist adc module maxmodule alladcs allmodules

#    implement the all modules and all groups features
#    also retry writes because the VF48 is rather unreliable

     set EGallow 0x2000a

     set runstate [read-vme-register $modulename#$module.CSR.Run]
     if {$runstate != 0} {
         midas-warning "VF48 module parameters cannot be read or written while running"
         set EGallow 0xffffffff
         return "WTERR"
     }

    set module_SAVE $module
    set adc_SAVE $adc

    if {$allmodules} {set modules $modulelist} else {set modules $module}
    if {$alladcs} {set adcs [list 0 1 2 3 4 5]} else {set adcs $adc}

    foreach module $modules {

       foreach adc $adcs {

          for {set tries 1} {$tries < 10} {incr tries} {

              set param [WriteParameter $p $vl]
              set param [ReadParameter $p]
              if {$param == "RDERR"} {break}
              if {$param == $vl} {break}
          }

          if {$tries == 10} {midas-warning "Set Parameter $p aborted after 10 attempts"; set tries 1}
          if {$tries > 1} {set-footer "Set Parameter $p required $tries attempts"; set tries 1}
       }
    }

    set module $module_SAVE
    set adc $adc_SAVE

    click_redisplay
}

proc WriteParameter {p vl} {
    global modulename module adc
    global EGallow 

     set EGallow 0x2000a

       set ParamID [expr ($adc << 12) + $p]

# insert-debug "write $modulename#$module.ParamID [format "0x%x" $ParamID]"

       write-vme-register $modulename#$module.ParamID $ParamID

# insert-debug "write $modulename#$module.ParamData [format "0x%x" $vl]"

       write-vme-register $modulename#$module.ParamData $vl

     set EGallow 0xffffffff
}

proc ReadParameter {p} {
    global modulename module adc
    global EGallow 

       set EGallow 0x2000a
       set ParamID [expr ($adc << 12) + 0x80 + $p]

       for {set tries 1} {$tries < 10} {incr tries} {

# insert-debug "write $modulename#$module.ParamID [format "0x%x" $ParamID]"
            write-vme-register $modulename#$module.ParamID $ParamID

# insert-debug "write $modulename#$module.ParamData 0"
            write-vme-register $modulename#$module.ParamData 0       ;#  this board needs dummy data!

            after 1

            set CSR [read-vme-register $modulename#$module.CSR]
# insert-debug "read  $modulename#$module.CSR $CSR"

           if {[expr $CSR & 4] == 4}  then {   ;# need bit 2

               set value [read-vme-register $modulename#$module.ParamData]
# insert-debug "read $modulename#$module.ParamData $value"

               set CSR [read-vme-register $modulename#$module.CSR]
# insert-debug "read  $modulename#$module.CSR $CSR"

               set EGallow 0xffffffff
               if {$value == 0x2000a} then {set value "BERR"}
               return $value
           }
       }

       set EGallow 0xffffffff
       return "RDERR"
}

proc click_reset {args} {
    global modulename module

    write-vme-register $modulename#$module.Reset 0
}

proc click_csr {vl} {
    global modulename module

    write-vme-register $modulename#$module.CSR $vl
    :modify CSR :value [read-vme-register $modulename#$module.CSR]
}

proc click_enable {vl} {
    global modulename module

    write-vme-register $modulename#$module.GrpEnable $vl
    :modify ENABLE :value [read-vme-register $modulename#$module.GrpEnable]
}

proc click_b11 {vl} {
    global EGallow modulename module

       set EGallow 0x2000a
       set runstate [read-vme-register $modulename#$module.CSR.Run]
       if {$runstate != 0} {
          midas-warning "VF48 module parameters cannot be read or written while running"
          set EGallow 0xffffffff
          return
       }

    set p [ReadParameter 10]
    if {$p == "RDERR"} {return}
    SetParameter 10 [expr ($p & 0xfffd) | ($vl << 1)]
}

proc click_b20 {vl} {
    global EGallow modulename module

       set EGallow 0x2000a
       set runstate [read-vme-register $modulename#$module.CSR.Run]
       if {$runstate != 0} {
          midas-warning "VF48 module parameters cannot be read or written while running"
          set EGallow 0xffffffff
          return
       }

    set p [ReadParameter 15]
    if {$p == "RDERR"} {return}
    SetParameter 15 [expr ($p & 0xfffe) | $vl]
}

proc click_b21 {vl} {
    global EGallow modulename module

       set EGallow 0x2000a
       set runstate [read-vme-register $modulename#$module.CSR.Run]
       if {$runstate != 0} {
          midas-warning "VF48 module parameters cannot be read or written while running"
          set EGallow 0xffffffff
          return
       }

    set p [ReadParameter 15]
    if {$p == "RDERR"} {return}
    SetParameter 15 [expr ($p & 0xfffd) | ($vl << 1)]
}

proc click_read {args} {
    global modulename module
    global EGallow

    set register "DataFiFo"
    set EGallow 0x2000a
    set value [read-vme-register $modulename#$module.$register]
    set EGallow 0xffffffff
    if {$value == 0x2000a} then {set value "BERR"}
    :modify FIFO :value $value
}

proc click_show {args} {
  global  modulename module EGreport

    set EGreport_SAVE $EGreport
    set EGreport -1

   set-busy

   set Nbr [read-vme-register $modulename#$module.NbrFrames]

  set info "NbrFrames = $Nbr\n"
  for {set Offset 0} {$Offset < $Nbr} {incr Offset} {

     set register $modulename#$module.DataFiFo
     set data [string trimleft [read-vme-register $register]]

#     append info "\nData Register (FIFO) Offset $Offset - Contents $data\n"
     foreach word $data {
         set type [expr $word >> 28 & 15]
         switch $type {
           0 {
             set event_type "data"
             set s0 [expr $word & 0x3ff]
             set s1 [expr $word >> 16 & 0x3ff]
             append info "[format "0x%8x    %8s   sample n+1 = 0x%3x;  sample n = 0x%3x" $word $event_type $s1 $s0]"
           }
           4 {
             set event_type "CFD Time"
             set vl [expr $word & 0x00ffffff]
             append info "[format "0x%8x    %8s   0x%6x" $word $event_type $vl]"
           }
           5 {
             set event_type "Charge"
             set vl [expr $word & 0x00ffffff]
             append info "[format "0x%8x    %8s   0x%6x" $word $event_type $vl]"
           }
           8 {
             set event_type "Header"
             set trig [expr $word & 0x00ffffff]
             append info "[format "0x%8x    %8s;   trigger number= 0x%6x" $word $event_type $trig]"
           }
           10 {
             set event_type "Time Stamp"
             set vl [expr $word & 0x00ffffff]
             append info "[format "0x%8x    %8s   0x%6x" $word $event_type $vl]"
           }
           12 {
             set event_type "Channel ID"
             set group [expr $word >> 4 & 7]
             set channel [expr $word & 15]
             append info "[format "0x%8x    %8s   group= %d;   channel= %d" $word $event_type $group $channel]"
           }
           14 {
             set event_type "Trailer"
             set trig [expr $word & 0x00ffffff]
             append info "[format "0x%8x    %8s;   trigger number= 0x%6x" $word $event_type $trig]"
           }
           default {append info "[format "0x%8x" $word]"}
         }
         append info "\n"
     }
  }
  append info "end of fifo reached\n"

   clear-busy
   set EGreport $EGreport_SAVE

  midas-information $info
}

proc click arg {
   global debug allmodules alladcs
   if {$debug} then {puts insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {click-quit; return}
   clear-footer
   switch -glob $w {

      MODULE-SEL      -
      MODULE-NUM {click-select-module $v}

      ADC-NUM    {click-select-adc $v}

      ALL-MODULES {set allmodules $v}
      ALL-ADCS    {set alladcs $v}

      P*    {SetParameter [string range $w 1 end] $v}

      ENGINEERING       {click-$v}

      default           {
           set p "click_[lowercase $w]"
           if {[info procs $p] == "$p"} then {$p $v} else {insert-debug "$arg"}
      }
   }
}

proc make-frame {} {
  global env module maxmodule modulelist adc
   global alladcs allmodules

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10 :pady 10
      :layout H; :row-gap 10; :col-gap 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 :value $module
      :menubutton MODULE-SEL :label "select:" :strings $modulelist

      :choice-stack ADC-NUM  :label "Channel Group:" :strings [list 1-8 9-16 17-24 25-32 33-40 41-48] :value $adc

      :hskip 20
      :checkbox ALL-ADCS :label "Act on all groups" :value $alladcs
      :checkbox ALL-MODULES  :label "Act on all modules"  :value $allmodules

      :next-row T
      :col-gap 15
      :text CSR  :label "CSR"  :w 6 :deaf T
      :text NBRF :label "Data Words Pending"   :w 6  :deaf T
      :checkbox EXTTRIG :label "External Trigger"
      :checkbox RUN :label "Run" :deaf T
      :checkbox CRC :label "CRC error" :deaf T
      :checkbox DRDY :label "Event Fifo Empty" :deaf T

      :next-row T
      :choice ENABLE :label "Enable Channel Group" :strings [list 1-8 9-16 17-24 25-32 33-40 41-48]  :exclusive F :w 5

   :panel PARAM :layout T :padx 10 :pady 10
      :layout H; :row-gap 10; :col-gap 10

      :message M1 :label "Channel Group Parameters"
      :col-gap 0
      :next-row T
#      :text P1  :label "PED"                :w 8  :valuex 16c
      :text P2  :label "Hit Det Threshold"  :w 8  :valuex 16c
#      :text P3  :label "Clip Delay"         :w 8  :valuex 16c
      :text P4  :label "Pre Trigger"        :w 8  :valuex 16c
      :text P5  :label "Segment Size"       :w 8  :valuex 16c
#      :text P6  :label "K"                  :w 8  :valuex 16c
#      :text P7  :label "L"                  :w 8  :valuex 16c
#      :text P8  :label "M"                  :w 8  :valuex 16c
#      :text P9  :label "Feature Delay A"    :w 8  :valuex 16c
      :text P10 :label "Mbits 1"              :w 8  :valuex 16c

      :next-row T

#      :text P11 :label "Feature Delay B"    :w 8  :valuex 16c
      :text P12 :label "Latency"            :w 8  :valuex 16c
      :text P13 :label "Firmware ID"        :w 8  :valuex 16c  :deaf T
#      :text P14 :label "Attenuator"         :w 8  :valuex 16c
      :text P15 :label "Mbits 2"              :w 8  :valuex 16c
      :text P16 :label "Channel Enable"              :w 8  :valuex 16c

      :next-row T
       :checkbox B11 :label "Suppress Raw Data"  :valuex 28c
       :checkbox B20 :label "Suppress Charge Datum" :valuex 28c
       :checkbox B21 :label "Suppress Time Datum" :valuex 28c

   :panel CLICK :layout T :padx 10
      :layout H; :col-gap 25

      :button REDISPLAY
      :menubutton ENGINEERING :label "Engineering"  :menu [list software registers]
      :button RESET :label "Module Global Reset" 
      :button SHOW :label "Show Data FIFO"

   :show T
}


proc midas-information {text} {

    set frame [self frame-name].info

    :frame $frame :label  "Information from [self frame-title]" :toplevel T
         wm protocol $frame WM_DELETE_WINDOW "destroy $frame"

    :galley G :deaf T :strings $text :cols 80 :rows 80 :font "fixed"
    :show T
}

